/***********************************************************
 *  bgset.h   version 0.3.4
 *  License: GPL
 *  all stuff done by Juergen Repolusk <juerep@gmx.at>
 *
 *  this stuff is responsible for doing the bsetbg
 *  execute stuff.
 *
 ***********************************************************/


#if !defined(__BGSET_H__)
#define __BGSET_H__

#include <string.h>
#include <stdlib.h>

#include "get_bg_command.h"

const char *filename;
char *bgcommand = get_bg_command(); // command for setting up the background
char *option = "-f"; // standart set at full view
char *tcom = "<not yet set>";
char *m_m_result;

char* make_message(char *name, const char *value)
{
	m_m_result = (char *) malloc(strlen(get_bg_command())+1+strlen(name)+1+strlen(value)+1);
	if (sprintf(m_m_result, "%s %s %s",get_bg_command(), name, value) < 0)
		return NULL;
	printf("%s\n", m_m_result);
	return m_m_result;
}

void free_make_message_res(void)
{
	free(m_m_result);
};



int set_bg(void)
{
	/*printf("doing background set with option: %s \n", option);/* just testing*/
	tcom = make_message(option, filename);

	if (system((const char*) tcom)){
	         printf("background could not be set... \n");
		 /*printf("might be a failure!?\n");*/
		 return 1;
        };

	free_make_message_res();

	return 0;
										}
int set_solid_bg(int red, int blue, int green)
{

	red = (int) (((double) red/256)/25.6);
	blue = (int) (((double) blue/256)/25.6);
	green = (int) ((double)(green/256)/25.6);

	char *rgb_text;
	/*
	printf("setting up solid colors: \n");
	printf("red: %d \n", red);
	printf("blue: %d \n", blue);
	printf("green: %d \n", green);
	*/

	/* do it like: -solid RGB:2/3/3 */
	rgb_text = (char *) malloc(6+3+1); /*TODO: FREE IT!*/
	if (sprintf(rgb_text, "RGB:%d/%d/%d",red, green, blue) <0){
		printf("could not merge colors together");
		return 1;
	}
	/*printf("do solid with: %s\n", rgb_text);  /*  just testing */
	filename = rgb_text;
	free(rgb_text); /*DOES THIS WORKS?*/
	return 0;
}



void set_center(void)
{
	option="-c";
}

void set_full(void)
{
	option="-f";
}

void set_tile(void)
{
	option="-t";
}
void set_solid(void)
{
	option="-solid";
}


#endif /*__BGSET_H__*/
