/*  bgset.hh   version 0.3
 *  License: GPL
 *  all stuff done by Juergen Repolusk <juerep@gmx.at>
 *
 *  this stuff is responsible for doing the bsetbg 
 *  execute stuff. 
 */




#include <string.h>
#include <stdlib.h>
// #include <iostream>

const char *filename;
char *bgcommand = "bsetbg"; // command for setting up the background
char *option = "-full"; // standart set at full view
char *tcom = "<not yet set>";

char* make_message(char *name, const char *value)
{
	char *result;
	if (asprintf(&result, "bsetbg %s %s", name, value) < 0)
		return NULL;
	return result;
}

int set_bg(void)
{
	printf("doing background set with option: %s \n", option);	
	tcom = make_message(option, filename);

	if (system((const char*) tcom)){
	         printf("background could not be set... \n");
		 printf("might be a failure!?\n");
		 return 1;
        };

	return 0;
										}
int set_solid_bg(int red, int blue, int green)
{
	// problem: colors only from 0 to 9 allowed
	// this makes the quality worse!
	// dirty division ahead!
	red = (red/256)/25.6;
	blue = (blue/256)/25.6;
	green = (green/256)/25.6;
	
	char *rgb_text;
	printf("setting up solid colors: \n");
	printf("red: %d \n", red);
	printf("blue: %d \n", blue);
	printf("green: %d \n", green);
	// like: -solid RGB:2/3/3
	if (asprintf(&rgb_text, "RGB:%d/%d/%d",red, green, blue) <0){
		printf("could not merge colors together");
		return 1;
	}
	printf("do solid with: %s\n", rgb_text);
	filename = rgb_text;
	return 0;
}



void set_center(void)
{
	option="-center";
}

void set_full(void)
{
	option="-full";
}

void set_tile(void)
{
	option="-tile";
}
void set_solid(void)
{
	option="-solid";
}
