/**************************************************************
 *	file_vect.hh	version: 0.1.3
 *	licence: GPL
 *	all done by juergen repolusk <juerep@gmx.at>
 *
 *	class to store a file&option vector, to read it out
 *	and to save everything into a file if wanted
 *
 *************************************************************/

#if !defined(__FILE_VECT_HH__)
#define __FILE_VECT_HH__


 #include <vector>

 using namespace std;



 class file_class
 {


 protected:

 	struct file_struct{
		char * filename;
		char * option;
		};


	vector <file_struct> file_vector;


 public:
	char* pub_filename;
	char* pub_option;

	file_class();
	virtual ~file_class();


	/// Function to push filename and option into the vector
 	void push_it(char *, char *);
	/// Function to read out filename from the vector
	char* pull_filename(void);
	/// Function to read out the options from the vector
	char* pull_option(void);
	/// this function is just for testing
	void print_it(void);
	/// push the vector into a file
	void push_to_file(const char *);
 };


#endif // __FILE_VECT_HH__
