/*****************************************************************************
 * fluxbg_conf.cc	version: 0.2
 *	done by jvr <juerep@gmx.at>
 *
 * actually this tool should generate automaticly generate a configuration file
 * for your fluxbg and fluxbgd tool.
 *
 *******************************************************************************/

#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <errno.h>
#include <string.h>

extern "C"{
	#include "getinfo.h"
}

 #define FLUXBG_CONF_FILE ".fluxbg"


using namespace std;

char * fluxbg_config_file;
const char *szCommand = "<not yet set>";





 void PrintError(const char*szMessage)
 {
        if(errno != 0)
        {
                (void) fprintf(stderr, "%s: %s\n", szCommand, szMessage);
        }
        else
        {
                (void) fprintf(stderr, "%s: %s\n", szCommand, szMessage);
        }

 	exit(EXIT_FAILURE);
 }










/*writes the name into the config file*/
/*returns 1 if success at writing */

int write_name_to_conf(const char *name){

char * local_path = get_user_path();
char * config_file = FLUXBG_CONF_FILE;

fluxbg_config_file = (char *) malloc(strlen(local_path)+strlen(config_file)+1);

 if (sprintf(fluxbg_config_file, "%s%s", local_path, config_file) < 0){
                PrintError("Could not merge user path with .fluxbg together");
        };

cout << "...writing to:" << fluxbg_config_file << endl;

ofstream outfl(fluxbg_config_file, ios::out);
        if (!outfl){
                cerr << "error while opening .fluxbg file!" << endl;
        }

outfl << "bg_command= " << name << endl;

free(fluxbg_config_file);

return 1;

}

int write_empty_conf(void){


char * local_path = get_user_path();
char * config_file = ".fluxbg";

fluxbg_config_file = (char *) malloc(strlen(local_path)+strlen(config_file)+1);

 if (sprintf(fluxbg_config_file, "%s%s", local_path, config_file) < 0){
                PrintError("Could not merge user path with .fluxbg together");
        };

cout << "...writing to:" << fluxbg_config_file << endl;

ofstream outfl(fluxbg_config_file, ios::out);
        if (!outfl){
                cerr << "error while opening .fluxbg file!" << endl;
        }

outfl << "bg_command= " << "insert_path_to_background_command" << endl;


free(fluxbg_config_file);

return 1;

}






/* function that try to access to a file called name*/
/* returns 1 if acess granded and 0 if not granded  */

int try_access(const char * name){
cout << "trying to get acess to: " << name ;

if (access(name, X_OK)==0){
	cout << " ...access granded!" << endl;
	cout << "write to config file now" << endl;
	if (write_name_to_conf(name) == 1){
		cout << "writing config file was successful..." << endl;
		/* BAIL OUT*/
		}
	return 1;
	}
cout << " ...access NOT granded!" << endl;
return 0;

}


void BailOut(void){
	cout << "finished all work now - bailing out" << endl;
	exit(EXIT_SUCCESS);
}







int main(int argc, char *argv[]){

szCommand= argv[0];
cout << "fluxbg_config: stupid configuration tool done by <juerep@gmx.at>" << endl;
cout << "****************************************************************" << endl;
cout << "...start to try some directories" << endl;


/* trying if its installed in /usr/bin */

if (try_access("/usr/bin/bsetbg")==1)
	BailOut();

if (try_access("/usr/bin/fbsetbg")==1)
	BailOut();

/* might be a local installation ? */

if (try_access("/usr/local/bin/bsetbg")==1)
	BailOut();

if (try_access("/usr/local/bin/fbsetbg")==1)
	BailOut();

/*added for FreeBSD support to look into /usr/X11R6/ */
if (try_access("/usr/X11R6/bin/bsetbg")==1)
	BailOut();

if (try_access("/usr/X11R6/bin/fbsetbg")==1)
	BailOut();

/* the same again for local*/
if (try_access("/usr/X11R6/local/bsetbg")==1)
	BailOut();

if (try_access("/usr/X11R6/local/fbsetbg")==1)
	BailOut();
/* and the same again for fbsetbg-devel */
if (try_access("/usr/bin/fbsetbg-devel")==1)
	BailOut();

if (try_access("/usr/local/bin/fbsetbg-devel")==1)
	BailOut();

if (try_access("/usr/X11R6/bin/fbsetbg-devel")==1)
	BailOut();




if (write_empty_conf()!=1)
	PrintError("Could not generate config file!");

cout << "could not find your fluxbox bsetbg/fbsetbg installation! " << endl;
cout << "******************************************************** " << endl;
cout << "you have to set the path to your bsetbg or fbsetbg commmand" << endl;
cout << "yourselfe by changing your .fluxbg file in your home directory. " << endl;
cout << "simply do something like pico ~/.fluxbg " << endl;

return 0;
}
